<template>
  <div class="line-chart">
    <div class="flex justify-between pb-2">
      <div class="font-semibold text-xl">{{ title }}</div>
    </div>

    <div style="height: calc(100% - 36px)">
      <canvas :id="title"></canvas>
    </div>
  </div>
</template>

<script>
import Chart from "chart.js/auto";
import _ from "lodash";

export default {
  props: {
    title: {
      type: String,
      default: "Title",
    },
    chart_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
  },
  data() {
    return {
      chart: null,
    };
  },
  watch: {
    chart_data(newValue, oldValue) {
      this.updateChart();
    },
  },
  mounted() {
    this.setChart();
  },
  methods: {
    setChart() {
      const ctx = document.getElementById(`${this.title}`);

      const options = {
        maintainAspectRatio: false,
        plugins: {
          tooltip: {
            enabled: false,
          },
          legend: {
            display: false,
          },
        },
        scales: {
          x: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
          y: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
        },
      };

      const data = {
        labels: _.map(this.chart_data, (d) => d.time),
        datasets: [
          {
            data: _.map(this.chart_data, (d) => d.value),
            borderColor: "#00D1E3",
            pointRadius: 0,
          },
        ],
      };

      const config = {
        type: "line",
        data,
        options,
      };

      Chart.defaults.font.family = "Kanit";
      Chart.defaults.font.size = 12;
      Chart.defaults.font.weight = 300;
      Chart.defaults.color = "white";
      this.chart = new Chart(ctx, config);
    },
    updateChart() {
      this.chart.data.datasets = [
        {
          data: _.map(this.chart_data, (d) => d.value),
          borderColor: "#00D1E3",
          pointRadius: 0,
        },
      ];
      this.chart.data.labels = _.map(this.chart_data, (d) => d.time);
      this.chart.update();
    },
  },
};
</script>

<style lang="scss" scoped></style>
